<?php

chdir ('../../');
require_once('api/Fivecms.php');
$fivecms = new Fivecms();

if (!(isset($_POST["id"]) && isset($_POST["orderid"])))
{
    die("The payment number and transaction ID are missing!");
}

$id 			= $_POST["id"];
$sum 			= $_POST['sum'];
$orderid 		= intval($_POST['orderid']);
$clientid 		= $_POST["clientid"];
$key 			= $_POST["key"];

$order = $fivecms->orders->get_order(intval($orderid));
if(empty($order)) {
	die('FAIL. Order not found');
}

if($order->paid) {
    die('FAIL. Order is already payed');
}

$method = $fivecms->payment->get_payment_method(intval($order->payment_method_id));
if(empty($method))
die("FAIL. Payment method not defined");

$settings = unserialize($method->settings);
$secret_seed = $settings["secret_word"];
if ($key != md5 ($id . sprintf ("%.2lf", $sum).$clientid.$orderid.$secret_seed)) {
    die("Error! Hash mismatch");
}

if($sum != number_format($fivecms->money->convert($order->total_price, $method->currency_id, false),2,'.','')) {
	die("FAIL. Incorrect price\n");
}

$purchases = $fivecms->orders->get_purchases(array('order_id'=>intval($order->id)));
foreach($purchases as $purchase)
{
	$variant = $fivecms->variants->get_variant(intval($purchase->variant_id));
	if(empty($variant) || (!$variant->infinity && $variant->stock < $purchase->amount))
	{
		die("FAIL. Lack of product $purchase->product_name $purchase->variant_name");
	}
}

$fivecms->orders->set_pay(intval($order->id));

$fivecms->orders->close(intval($order->id));

$fivecms->notify->email_order_user(intval($order->id));
$fivecms->notify->email_order_admin(intval($order->id));
die("OK ".md5($id.$secret_seed));
